Merge tag 'x86_cleanups_for_v6.4_rc1' of git://git.kernel.org/pub/scm/linux/kernel...
[linux-block.git] / arch / powerpc / boot / wrapper
CommitLineData
2bf11819 1#!/bin/sh
00b46d22 2# SPDX-License-Identifier: GPL-2.0-only
2bf11819
PM
3
4# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
2bf11819
PM
5
6# This script takes a kernel binary and optionally an initrd image
7# and/or a device-tree blob, and creates a bootable zImage for a
8# given platform.
9
10# Options:
11# -o zImage specify output file
12# -p platform specify platform (links in $platform.o)
13# -i initrd specify initrd file
14# -d devtree specify device-tree blob
15# -s tree.dts specify device-tree source file (needs dtc installed)
528229d2 16# -e esm_blob specify ESM blob for secure images
2bf11819
PM
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
f1e510bb
OH
23# -z use gzip (legacy)
24# -Z zsuffix compression to use (gz, xz or none)
2bf11819 25
d4740373
GL
26# Stop execution if any command fails
27set -e
28
b949d009
CL
29export LC_ALL=C
30
7f66c1fd
GL
31# Allow for verbose output
32if [ "$V" = 1 ]; then
33 set -x
f61200d3 34 map="-Map wrapper.map"
7f66c1fd
GL
35fi
36
2bf11819
PM
37# defaults
38kernel=
39ofile=zImage
40platform=of
41initrd=
42dtb=
43dts=
528229d2 44esm_blob=
2bf11819 45cacheit=
11c146cc 46binary=
f1e510bb 47compression=.gz
fbded57c 48uboot_comp=gzip
6975a783 49pie=
147c0516 50format=
4c078c86 51notext=
26ba9f96 52rodynamic=
2bf11819
PM
53
54# cross-compilation prefix
55CROSS=
56
3f884bf5
PT
57# mkimage wrapper script
58MKIMAGE=$srctree/scripts/mkuboot.sh
59
2bf11819
PM
60# directory for object and other files used by this script
61object=arch/powerpc/boot
5c539ee3 62objbin=$object
c79b2973 63dtc=scripts/dtc/dtc
2bf11819
PM
64
65# directory for working files
66tmpdir=.
67
68usage() {
69 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
528229d2
BH
70 echo ' [-d devtree] [-s tree.dts] [-e esm_blob]' >&2
71 echo ' [-c] [-C cross-prefix] [-D datadir] [-W workingdir]' >&2
72 echo ' [-Z (gz|xz|none)] [--no-compression] [vmlinux]' >&2
2bf11819
PM
73 exit 1
74}
75
879c26d4
GL
76run_cmd() {
77 if [ "$V" = 1 ]; then
78 $* 2>&1
79 else
80 local msg
81
82 set +e
83 msg=$($* 2>&1)
84
85 if [ $? -ne "0" ]; then
86 echo $msg
87 exit 1
88 fi
89 set -e
90 fi
91}
92
2bf11819
PM
93while [ "$#" -gt 0 ]; do
94 case "$1" in
95 -o)
96 shift
97 [ "$#" -gt 0 ] || usage
98 ofile="$1"
99 ;;
100 -p)
101 shift
102 [ "$#" -gt 0 ] || usage
103 platform="$1"
104 ;;
105 -i)
106 shift
107 [ "$#" -gt 0 ] || usage
108 initrd="$1"
109 ;;
110 -d)
111 shift
112 [ "$#" -gt 0 ] || usage
113 dtb="$1"
114 ;;
528229d2
BH
115 -e)
116 shift
117 [ "$#" -gt 0 ] || usage
118 esm_blob="$1"
119 ;;
2bf11819
PM
120 -s)
121 shift
122 [ "$#" -gt 0 ] || usage
123 dts="$1"
124 ;;
125 -c)
126 cacheit=y
127 ;;
128 -C)
129 shift
130 [ "$#" -gt 0 ] || usage
131 CROSS="$1"
132 ;;
133 -D)
134 shift
135 [ "$#" -gt 0 ] || usage
136 object="$1"
5c539ee3 137 objbin="$1"
2bf11819
PM
138 ;;
139 -W)
140 shift
141 [ "$#" -gt 0 ] || usage
142 tmpdir="$1"
143 ;;
f1e510bb
OH
144 -z)
145 compression=.gz
fbded57c 146 uboot_comp=gzip
f1e510bb
OH
147 ;;
148 -Z)
149 shift
150 [ "$#" -gt 0 ] || usage
264bffad 151 [ "$1" != "gz" -o "$1" != "xz" -o "$1" != "lzma" -o "$1" != "lzo" -o "$1" != "none" ] || usage
f1e510bb
OH
152
153 compression=".$1"
fbded57c 154 uboot_comp=$1
f1e510bb
OH
155
156 if [ $compression = ".none" ]; then
157 compression=
fbded57c 158 uboot_comp=none
f1e510bb 159 fi
fbded57c
CL
160 if [ $uboot_comp = "gz" ]; then
161 uboot_comp=gzip
162 fi
f1e510bb 163 ;;
a9903811 164 --no-gzip)
87c78b61 165 # a "feature" of the wrapper script is that it can be used outside
f1e510bb
OH
166 # the kernel tree. So keeping this around for backwards compatibility.
167 compression=
fbded57c 168 uboot_comp=none
a9903811 169 ;;
2bf11819
PM
170 -?)
171 usage
172 ;;
173 *)
174 [ -z "$kernel" ] || usage
175 kernel="$1"
176 ;;
177 esac
178 shift
179done
180
f1e510bb 181
2bf11819 182if [ -n "$dts" ]; then
701172d1
DW
183 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
184 dts="$object/dts/$dts"
185 fi
2bf11819
PM
186 if [ -z "$dtb" ]; then
187 dtb="$platform.dtb"
188 fi
c79b2973 189 $dtc -O dtb -o "$dtb" -b 0 "$dts"
2bf11819
PM
190fi
191
192if [ -z "$kernel" ]; then
193 kernel=vmlinux
194fi
195
77a88274 196LC_ALL=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
147c0516
CLG
197case "$elfformat" in
198 elf64-powerpcle) format=elf64lppc ;;
199 elf64-powerpc) format=elf32ppc ;;
200 elf32-powerpc) format=elf32ppc ;;
201esac
202
ff45000f
NP
203ld_version()
204{
205 # Poached from scripts/ld-version.sh, but we don't want to call that because
206 # this script (wrapper) is distributed separately from the kernel source.
207 # Extract linker version number from stdin and turn into single number.
208 awk '{
209 gsub(".*\\)", "");
210 gsub(".*version ", "");
211 gsub("-.*", "");
212 split($1,a, ".");
3287ebd7
OM
213 if( length(a[3]) == "8" )
214 # a[3] is probably a date of format yyyymmdd used for release snapshots. We
215 # can assume it to be zero as it does not signify a new version as such.
216 a[3] = 0;
ff45000f
NP
217 print a[1]*100000000 + a[2]*1000000 + a[3]*10000;
218 exit
219 }'
220}
221
579aee9f
SR
222ld_is_lld()
223{
224 ${CROSS}ld -V 2>&1 | grep -q LLD
225}
226
ff45000f
NP
227# Do not include PT_INTERP segment when linking pie. Non-pie linking
228# just ignores this option.
229LD_VERSION=$(${CROSS}ld --version | ld_version)
230LD_NO_DL_MIN_VERSION=$(echo 2.26 | ld_version)
231if [ "$LD_VERSION" -ge "$LD_NO_DL_MIN_VERSION" ] ; then
232 nodl="--no-dynamic-linker"
233fi
147c0516 234
579aee9f
SR
235# suppress some warnings in recent ld versions
236nowarn="-z noexecstack"
237if ! ld_is_lld; then
238 if [ "$LD_VERSION" -ge "$(echo 2.39 | ld_version)" ]; then
239 nowarn="$nowarn --no-warn-rwx-segments"
240 fi
241fi
242
2bf11819
PM
243platformo=$object/"$platform".o
244lds=$object/zImage.lds
245ext=strip
246objflags=-S
247tmp=$tmpdir/zImage.$$.o
248ksection=.kernel:vmlinux.strip
249isection=.kernel:initrd
528229d2 250esection=.kernel:esm_blob
9b09c6d9 251link_address='0x400000'
dfbc2d75 252make_space=y
2bf11819 253
528229d2
BH
254
255if [ -n "$esm_blob" -a "$platform" != "pseries" ]; then
256 echo "ESM blob not support on non-pseries platforms" >&2
257 exit 1
258fi
259
2bf11819 260case "$platform" in
44790a0b
BH
261of)
262 platformo="$object/of.o $object/epapr.o"
263 make_space=n
264 ;;
9b09c6d9 265pseries)
2d9afb36 266 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
9b09c6d9 267 link_address='0x4000000'
147c0516
CLG
268 if [ "$format" != "elf32ppc" ]; then
269 link_address=
270 pie=-pie
271 fi
f5467e28 272 make_space=n
9b09c6d9 273 ;;
58706ef9 274maple)
0c9fa291 275 platformo="$object/of.o $object/epapr.o"
58706ef9 276 link_address='0x400000'
f5467e28 277 make_space=n
58706ef9 278 ;;
9b09c6d9 279pmac|chrp)
0c9fa291 280 platformo="$object/of.o $object/epapr.o"
f5467e28 281 make_space=n
2bf11819 282 ;;
627aa944 283coff)
0c9fa291 284 platformo="$object/crt0.o $object/of.o $object/epapr.o"
2bf11819 285 lds=$object/zImage.coff.lds
9b09c6d9 286 link_address='0x500000'
f5467e28 287 make_space=n
6975a783 288 pie=
2bf11819 289 ;;
11eab297 290miboot|uboot*)
2bf11819
PM
291 # miboot and U-boot want just the bare bits, not an ELF binary
292 ext=bin
293 objflags="-O binary"
294 tmp="$ofile"
295 ksection=image
296 isection=initrd
297 ;;
0fdd717e 298cuboot*)
11c146cc 299 binary=y
f1e510bb 300 compression=
25431333 301 case "$platform" in
8dd217b2 302 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
25431333
GL
303 platformo=$object/cuboot-8xx.o
304 ;;
305 *5200*|*-motionpro)
306 platformo=$object/cuboot-52xx.o
307 ;;
308 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
309 platformo=$object/cuboot-pq2.o
310 ;;
311 *-mpc824*)
312 platformo=$object/cuboot-824x.o
313 ;;
59d13f9d 314 *-mpc83*|*-asp834x*)
25431333
GL
315 platformo=$object/cuboot-83xx.o
316 ;;
ff880112 317 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
25431333
GL
318 platformo=$object/cuboot-85xx-cpm2.o
319 ;;
c12adb06 320 *-mpc85*|*-tqm85*)
25431333
GL
321 platformo=$object/cuboot-85xx.o
322 ;;
8f23735d
GP
323 *-amigaone)
324 link_address='0x800000'
325 ;;
25431333 326 esac
0fdd717e 327 ;;
bafdb645
GL
328ps3)
329 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
330 lds=$object/zImage.ps3.lds
f1e510bb 331 compression=
bafdb645
GL
332 ext=bin
333 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
334 ksection=.kernel:vmlinux.bin
335 isection=.kernel:initrd
9b09c6d9 336 link_address=''
dfbc2d75 337 make_space=n
6975a783 338 pie=
bafdb645 339 ;;
a55387e5 340ep88xc|ep405|ep8248e)
11c146cc
SW
341 platformo="$object/fixed-head.o $object/$platform.o"
342 binary=y
343 ;;
a55387e5
SW
344adder875-redboot)
345 platformo="$object/fixed-head.o $object/redboot-8xx.o"
346 binary=y
347 ;;
1d46e379 348simpleboot-*)
a7e1cf0c 349 platformo="$object/fixed-head.o $object/simpleboot.o"
1d46e379
GL
350 binary=y
351 ;;
59d13f9d
BD
352asp834x-redboot)
353 platformo="$object/fixed-head.o $object/redboot-83xx.o"
354 binary=y
355 ;;
24760823
NC
356xpedite52*)
357 link_address='0x1400000'
358 platformo=$object/cuboot-85xx.o
359 ;;
6cdd2417 360gamecube|wii)
b68a24bc
AH
361 link_address='0x600000'
362 platformo="$object/$platform-head.o $object/$platform.o"
363 ;;
4a21192e
JS
364microwatt)
365 link_address='0x500000'
366 platformo="$object/fixed-head.o $object/$platform.o"
367 binary=y
368 ;;
228d5505
TB
369treeboot-currituck)
370 link_address='0x1000000'
371 ;;
2a2c74b2
AP
372treeboot-akebono)
373 link_address='0x1000000'
374 ;;
b4e8c8dd
TS
375treeboot-iss4xx-mpic)
376 platformo="$object/treeboot-iss4xx.o"
377 ;;
6c5b59b9 378epapr)
90d1d44e 379 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
6c5b59b9
DG
380 link_address='0x20000000'
381 pie=-pie
4c078c86 382 notext='-z notext'
26ba9f96 383 rodynamic=$(if ${CROSS}ld -V 2>&1 | grep -q LLD ; then echo "-z rodynamic"; fi)
6c5b59b9 384 ;;
be201981
SC
385mvme5100)
386 platformo="$object/fixed-head.o $object/mvme5100.o"
387 binary=y
388 ;;
97493e2e
AIB
389mvme7100)
390 platformo="$object/motload-head.o $object/mvme7100.o"
391 link_address='0x4000000'
392 binary=y
393 ;;
2bf11819
PM
394esac
395
396vmz="$tmpdir/`basename \"$kernel\"`.$ext"
a9903811 397
f1e510bb
OH
398# Calculate the vmlinux.strip size
399${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
a670b0b4 400strip_size=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" "$vmz.$$")
c55aef0e 401
f1e510bb
OH
402if [ -z "$cacheit" -o ! -f "$vmz$compression" -o "$vmz$compression" -ot "$kernel" ]; then
403 # recompress the image if we need to
404 case $compression in
405 .xz)
406 xz --check=crc32 -f -6 "$vmz.$$"
407 ;;
408 .gz)
c4f56af0 409 gzip -n -f -9 "$vmz.$$"
f1e510bb 410 ;;
1cc9a21b
CL
411 .lzma)
412 xz --format=lzma -f -6 "$vmz.$$"
413 ;;
264bffad
CL
414 .lzo)
415 lzop -f -9 "$vmz.$$"
416 ;;
f1e510bb
OH
417 *)
418 # drop the compression suffix so the stripped vmlinux is used
419 compression=
fbded57c 420 uboot_comp=none
f1e510bb
OH
421 ;;
422 esac
a9903811 423
2bf11819 424 if [ -n "$cacheit" ]; then
f1e510bb 425 mv -f "$vmz.$$$compression" "$vmz$compression"
2bf11819
PM
426 else
427 vmz="$vmz.$$"
428 fi
c55aef0e 429else
c55aef0e
SP
430 rm -f $vmz.$$
431fi
432
f1e510bb
OH
433vmz="$vmz$compression"
434
dfbc2d75
SR
435if [ "$make_space" = "y" ]; then
436 # Round the size to next higher MB limit
437 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
c55aef0e 438
dfbc2d75
SR
439 round_size=0x$(printf "%x" $round_size)
440 link_addr=$(printf "%d" $link_address)
c55aef0e 441
dfbc2d75
SR
442 if [ $link_addr -lt $strip_size ]; then
443 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
444 "overlaps the address of the wrapper($link_address)"
445 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
446 link_address=$round_size
447 fi
2bf11819
PM
448fi
449
a6afacb6
DG
450# Extract kernel version information, some platforms want to include
451# it in the image header
452version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
2df8220c 453 head -n1 | cut -d' ' -f3`
a6afacb6
DG
454if [ -n "$version" ]; then
455 uboot_version="-n Linux-$version"
456fi
0fdd717e 457
b18796d3
KG
458# physical offset of kernel image
459membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
460
0fdd717e
SW
461case "$platform" in
462uboot)
463 rm -f "$ofile"
fbded57c 464 ${MKIMAGE} -A ppc -O linux -T kernel -C $uboot_comp -a $membase -e $membase \
a6afacb6 465 $uboot_version -d "$vmz" "$ofile"
2bf11819 466 if [ -z "$cacheit" ]; then
a9903811 467 rm -f "$vmz"
2bf11819
PM
468 fi
469 exit 0
470 ;;
11eab297
BH
471uboot-obs600)
472 rm -f "$ofile"
473 # obs600 wants a multi image with an initrd, so we need to put a fake
474 # one in even when building a "normal" image.
475 if [ -n "$initrd" ]; then
476 real_rd="$initrd"
477 else
478 real_rd=`mktemp`
479 echo "\0" >>"$real_rd"
480 fi
481 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
482 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
483 if [ -z "$initrd" ]; then
484 rm -f "$real_rd"
485 fi
486 if [ -z "$cacheit" ]; then
487 rm -f "$vmz"
488 fi
489 exit 0
490 ;;
2bf11819
PM
491esac
492
493addsec() {
494 ${CROSS}objcopy $4 $1 \
495 --add-section=$3="$2" \
496 --set-section-flags=$3=contents,alloc,load,readonly,data
497}
498
a9903811 499addsec $tmp "$vmz" $ksection $object/empty.o
2bf11819 500if [ -z "$cacheit" ]; then
a9903811 501 rm -f "$vmz"
2bf11819
PM
502fi
503
504if [ -n "$initrd" ]; then
c888554b 505 addsec $tmp "$initrd" $isection
2bf11819
PM
506fi
507
508if [ -n "$dtb" ]; then
c888554b 509 addsec $tmp "$dtb" .kernel:dtb
e9c4b4bd
MG
510 if [ -n "$dts" ]; then
511 rm $dtb
512 fi
2bf11819
PM
513fi
514
528229d2
BH
515if [ -n "$esm_blob" ]; then
516 addsec $tmp "$esm_blob" $esection
517fi
518
2bf11819 519if [ "$platform" != "miboot" ]; then
9b09c6d9 520 if [ -n "$link_address" ] ; then
6975a783 521 text_start="-Ttext $link_address"
9b09c6d9 522 fi
f1e510bb 523#link everything
579aee9f 524 ${CROSS}ld -m $format -T $lds $text_start $pie $nodl $nowarn $rodynamic $notext -o "$ofile" $map \
cd197ffc 525 $platformo $tmp $object/wrapper.a
2bf11819
PM
526 rm $tmp
527fi
528
a6afacb6
DG
529# Some platforms need the zImage's entry point and base address
530base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
531entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
532
11c146cc
SW
533if [ -n "$binary" ]; then
534 mv "$ofile" "$ofile".elf
aeb4552f 535 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
11c146cc
SW
536fi
537
2bf11819
PM
538# post-processing needed for some platforms
539case "$platform" in
58706ef9 540pseries|chrp|maple)
5663a123 541 $objbin/addnote "$ofile"
0dcd4401 542 ;;
627aa944 543coff)
cd197ffc 544 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
5c539ee3 545 $objbin/hack-coff "$ofile"
2bf11819 546 ;;
0fdd717e 547cuboot*)
c4f56af0 548 gzip -n -f -9 "$ofile"
3f884bf5 549 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
aeb4552f 550 $uboot_version -d "$ofile".gz "$ofile"
0fdd717e 551 ;;
f6dfc805
DG
552treeboot*)
553 mv "$ofile" "$ofile.elf"
5c539ee3 554 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
f6dfc805
DG
555 if [ -z "$cacheit" ]; then
556 rm -f "$ofile.elf"
557 fi
558 exit 0
559 ;;
bafdb645 560ps3)
5761eaa3
GL
561 # The ps3's loader supports loading a gzipped binary image from flash
562 # rom to ram addr zero. The loader then enters the system reset
563 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
564 # a binary image of the kernel to be at addr zero, and yet have a
565 # suitable bootwrapper entry at 0x100. To construct the final rom
566 # image 512 bytes from offset 0x100 is copied to the bootwrapper
567 # place holder at symbol __system_reset_kernel. The 512 bytes of the
568 # bootwrapper entry code at symbol __system_reset_overlay is then
569 # copied to offset 0x100. At runtime the bootwrapper program copies
570 # the data at __system_reset_kernel back to addr 0x100.
bafdb645 571
aeb4552f 572 system_reset_overlay=0x`${CROSS}nm "$ofile" \
bafdb645
GL
573 | grep ' __system_reset_overlay$' \
574 | cut -d' ' -f1`
575 system_reset_overlay=`printf "%d" $system_reset_overlay`
aeb4552f 576 system_reset_kernel=0x`${CROSS}nm "$ofile" \
bafdb645
GL
577 | grep ' __system_reset_kernel$' \
578 | cut -d' ' -f1`
579 system_reset_kernel=`printf "%d" $system_reset_kernel`
580 overlay_dest="256"
5761eaa3 581 overlay_size="512"
bafdb645 582
aeb4552f
SW
583 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
584
879c26d4
GL
585 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
586 skip=$overlay_dest seek=$system_reset_kernel \
d4740373 587 count=$overlay_size bs=1
bafdb645 588
879c26d4
GL
589 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
590 skip=$system_reset_overlay seek=$overlay_dest \
d4740373 591 count=$overlay_size bs=1
bafdb645 592
928b9695 593 odir="$(dirname "$ofile.bin")"
aa3bc365
GL
594
595 # The ps3's flash loader has a size limit of 16 MiB for the uncompressed
596 # image. If a compressed image that exceeded this limit is written to
597 # flash the loader will decompress that image until the 16 MiB limit is
598 # reached, then enter the system reset vector of the partially decompressed
599 # image. No warning is issued.
600 rm -f "$odir"/{otheros,otheros-too-big}.bld
a9ffb8ee 601 size=$(${CROSS}nm --no-sort --radix=d "$ofile" | grep -E ' _end$' | cut -d' ' -f1)
aa3bc365
GL
602 bld="otheros.bld"
603 if [ $size -gt $((0x1000000)) ]; then
604 bld="otheros-too-big.bld"
605 fi
606 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/$bld"
bafdb645 607 ;;
2bf11819 608esac